import _slicedToArray from "@babel/runtime/helpers/esm/slicedToArray";
import { useEffect, useState } from "react";
export var useKeyPressed = function useKeyPressed(targetKey) {
  var _useState = useState(false),
      _useState2 = _slicedToArray(_useState, 2),
      keyPressed = _useState2[0],
      setKeyPressed = _useState2[1];

  var downHandler = function downHandler(_ref) {
    var key = _ref.key,
        ctrlKey = _ref.ctrlKey,
        altKey = _ref.altKey;
    if (ctrlKey && altKey && key === targetKey) setKeyPressed(true);
  };

  var upHandler = function upHandler(_ref2) {
    var key = _ref2.key,
        ctrlKey = _ref2.ctrlKey,
        altKey = _ref2.altKey;
    if (ctrlKey && altKey && key === targetKey) setKeyPressed(false);
  };

  useEffect(function () {
    window.addEventListener("keydown", downHandler);
    window.addEventListener("keyup", upHandler);
    return function () {
      window.removeEventListener("keydown", downHandler);
      window.removeEventListener("keyup", upHandler);
    };
  }, []);
  return keyPressed;
};